<?php
/**
 * @file nodereference_embed_plugin.inc
 * All embed plugins must extend this base class and implements its methods.
 */

abstract class nodereference_embed_plugin {

  public $title;

  /*
   *
   */
  public function __construct($title) {
    $this->title = $title;
  }

  /**
   * Get relevant data by id to be stored in the plugin object temporarily.
   * @param $id
   *   identifer for data source
   */
  public abstract function load($id);

  /*
   * Form array of configuration options which will be stored in variables
   * as system_settings_form() invocation is applied.
   * @return
   *   form array
   */
  public abstract function settings();

  /**
   * Theme the plugin with dynamic options.
   * @param $options
   *   array of theming options
   * @return
   *   rendered HTML representation
   */
  public abstract function render($options = array());

}